import ir.huri.jcal.JalaliCalendar;

import java.util.Objects;

/**
 * class for vote
 */
public class Vote {
    private Person person;
    private JalaliCalendar date;

    /**
     * @param person who voted
     * @param date jalali date of vote
     */
    public Vote(Person person, JalaliCalendar date) {
        this.date = date;
        this.person = person;
    }

    /**
     * @return voter
     */
    public Person getPerson() {
        return person;
    }

    /**
     * @return jalali date as a string
     */
    public JalaliCalendar getDate() {
        return date;
    }

    /**
     * @param o the object being compared
     * @return boolean value of equality
     */
    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Vote vote = (Vote) o;
        return getPerson().equals(vote.getPerson()) && getDate().equals(vote.getDate());
    }

    /**
     * @return hashcode person and date
     */
    @Override
    public int hashCode() {
        return Objects.hash(getPerson(), getDate());
    }
}
