import ir.huri.jcal.JalaliCalendar;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

/**
 * Voting Class
 */
public class Voting {
    private int type;
    private String question;
    private ArrayList<Person> voters;
    private HashSet<String> options;
    private HashMap<String, HashSet<Vote>> polls;

    /**
     * @return returns the question text
     */
    public String getQuestion() {
        return question;
    }

    /**
     * @param type type of voting. 0 is single and 1 is multiple
     * @param question question text of voting
     */
    public Voting(int type, String question) {
        this(type, question, new HashSet<>());

    }

    /**
     * @param type type of voting. 0 is single and 1 is multiple
     * @param question question text of voting
     * @param options options for voting
     */
    public Voting(int type, String question, HashSet<String> options) {
        this.type = type;
        this.question = question;
        this.options = options;
        this.voters = new ArrayList<Person>();
        this.polls = new HashMap<String, HashSet<Vote>>();
    }


    /**
     * @param string have no idea what it is
     */
    public void createPoll(String string) {
        // Not Clarified What It Does In The Documentation
    }

    /**
     * @param person voter
     * @param selectedOptions selected options by voter in multiple type
     */
    public void vote(Person person, ArrayList<String> selectedOptions) {

        this.voters.add(person);

        for (String selectedOption : selectedOptions) {
            if (!this.polls.containsKey(selectedOption)) {
                HashSet<Vote> voteSet = new HashSet<>();
                Vote vote = new Vote(person, new JalaliCalendar());
                voteSet.add(vote);
                this.polls.put(selectedOption, voteSet);
            }
            HashSet<Vote> voteSet = this.polls.get(selectedOption);
            voteSet.add(new Vote(person, new JalaliCalendar()));
            this.polls.put(selectedOption, voteSet);
        }
    }


    /**
     * @param person voter
     * @param selectedOption selected option by voter in single type
     */
    public void vote(Person person, String selectedOption) {
        this.voters.add(person);
        HashSet<Vote> voteSet = this.polls.containsKey(selectedOption) ?
                this.polls.get(selectedOption) : new HashSet<>();
        Vote vote = new Vote(person, new JalaliCalendar());
        voteSet.add(vote);
        this.polls.put(selectedOption, voteSet);
    }

    /**
     * @return voters list
     */
    public ArrayList<Person> getVoters() {
        return voters;
    }

    /**
     * @param type type of voting. 0 is single and 1 is multiple
     */
    public void printVotes(int type) {
        for (String option : this.options) {
            if (!this.polls.containsKey(option)) {
                System.out.println(option + " : 0");
            }

            HashSet<Vote> votes = this.polls.get(option);
            if (type == 0)
                System.out.println(option + " : " + votes.size());
            else {
                int size = votes.size() - 1;
                System.out.println(option + " : " + size);
            }


        }
    }

    /**
     * @return all polls
     */
    public HashMap<String, HashSet<Vote>> getPolls() {
        return polls;
    }

    /**
     * @return type of voting
     */
    public int getType() {
        return type;
    }
}
